;
; declare external variables
;

ext_near	macro	x
	irp	y, <x>
	extrn	y:near
	endm
		endm

ext_abs 	macro	x
	irp	y, <x>
	extrn	y:ABS
	endm
		endm

ext_far 	macro	x
	irp	y, <x>
	extrn	y:far
	endm
		endm

ext_byte	macro	x
	irp	y, <x>
	extrn	y:byte
	endm
		endm

ext_word	macro	x
	irp	y, <x>
	extrn	y:word
	endm
		endm

ext_dword	macro	x
	irp	y, <x>
	extrn	y:dword
	extrn	y&&_off:WORD
	extrn	y&&_seg:WORD
	endm
		endm

publics 	macro	X
	irp	y, <x>
	public	y
	endm
	endm

;
; declare the label is public
;

entry	macro	x
public	x
x:
	endm

;
; push a series registers
;

push_regs	macro	y
	irp	x, <y>
	push	x
	endm
	endm

;
; pop a series registers
;

pop_regs	macro	y
	irp	x, <y>
	pop	x
	endm
	endm

;
; reference the external label as data
;

refer1	macro	name, ext
public	name
	IF2
		IFNDEF ext
	EXTRN	ext:near
		ENDIF
	ENDIF
.cref
name	dw	ext
	endm

refer	macro	name
	IF2
		IFNDEF name
	EXTRN	name:NEAR
		ENDIF
	ENDIF
.cref
	dw	name
	endm

referw	macro	name
	IF2
		IFNDEF name
	EXTRN	name:WORD
		ENDIF
	ENDIF
.cref
	dw	name
	endm

referb	macro	name
	IF2
		IFNDEF name
	EXTRN	name:BYTE
		ENDIF
	ENDIF
.cref
	dw	name
	endm


;
; call a procedure that may be external.  The call will be short.
;

invoke	MACRO	name
.xcref
	IF2
	    IFNDEF name
	EXTRN	name:NEAR
	    ENDIF
	ENDIF
.cref
	CALL	name
ENDM
.xcref	invoke

;
; declare the symbol is public and determines the size
;

i_am	macro	name, size, init
public	name
IFIDN	<size>,<WORD>
	IFNB	<init>
name	dw	init
	ELSE
name	dw	?
	ENDIF
ELSE
	IFIDN	<size>,<DWORD>
public	name&_off, name&_seg
		IFB	<init>
name	label	dword
name&_off	dw	?
name&_seg	dw	?
		ELSE
name	dd	init
name&_off	EQU	word ptr name
name&_seg	EQU	word ptr name + 2
		ENDIF
	ELSE
		IFIDN	<size>,<BYTE>
			IFB	<init>
name	db	?
			ELSE
name	db	init
			ENDIF
		ELSE
			IFB	<init>
name	db	size dup (?)
			ELSE
name	db	size dup (init)
			ENDIF
		ENDIF
	ENDIF
ENDIF
	endm

;
; declare the symbol is public and determines the size
;

i_label macro	name, size
public	name
IFIDN	<size>,<WORD>
name	label	word
ELSE
	IFIDN	<size>,<DWORD>
name	label	dword
	ELSE
		IFIDN	<size>,<BYTE>
name	label	byte
		ENDIF
	ENDIF
ENDIF
	endm

;
; declare the procedure
;

i_proc	macro	name, type
public	name
	IFB	<type>
name	proc	near
	ELSE
name	proc	type
	ENDIF
	endm

;
; declare the symbol is public and defines the structure
;

i_struc macro	name, struct, init
public	name
	IFB	<init>
name	struct	<>
	ELSE
name	struct	init dup (<>)
	ENDIF
	endm

@delay	macro
	jmp	$+2
	endm

;
; declare a constant
;

i_abs	macro	name, init
public	name
name	EQU	init
	endm

@delay	macro
	jmp	$+2
	endm

;
; declare a variable external and allocate a size
;

I_NEED	MACRO	sym,len

    IFIDN   <len>,<WORD>
	EXTRN	&sym:WORD
    ELSE
	IFIDN	<len>,<DWORD>
	EXTRN	&sym:DWORD
	EXTRN	sym&_off:WORD
	EXTRN	sym&_seg:WORD
	ELSE
	EXTRN	&sym:BYTE
	ENDIF
    ENDIF
	ENDM

;
; jump to external label
;

jump	macro	name
	IF2
	    IFNDEF name
	EXTRN	name:NEAR
	    ENDIF
	ENDIF
.cref
	jmp	name
ENDM

;
; BREAK a listing into pages and give new subtitles
;

BREAK	MACRO	subtitle
	SUBTTL	subtitle
	PAGE
	ENDM
