@ScannerPort		EQU	271h
@EjectPaper		EQU	00010000B

;====== Leading Command Code ======

@SetScannerCommand	EQU	'a'
@InquireScannerCommand	EQU	's'
@SetDeviceCommand	EQU	'f'
@ClearErrorCommand	EQU	'o'
@UseToneMap		EQU	'u'

;======== Termination Code ========

@Inquire		EQU	'?'
@SetAutoBackgroundCtrl	EQU	'B'
@SetDataWidth		EQU	'D'
@ETerminator		EQU	'E'
@FTerminator		EQU	'F'
@HighestValueInquire	EQU	'H'
@SetInverseImage	EQU	'I'
@SetDitherPattern	EQU	'J'
@SetToneMap		EQU	'K'
@LowestValueInquire	EQU	'L'
@PTerminator		EQU	'P'
@QTerminator		EQU	'Q'
@RequestCurrentSetting	EQU	'R'
@SetYResolution 	EQU	'S'
@SetOutputDataType	EQU	'T'
@UpLoadBinaryData	EQU	'U'
@DownBinaryData 	EQU	'W'
@XTerminator		EQU	'X'
@YTerminator		EQU	'Y'

@InquireReturnValueTC	EQU	'V'

;ͻ
;								       
;ͼ

scanner_interface_struc struc
	scanner_command dw	?
	scan_variety	db	?
	scan_return	db	?
	buffer_leng	dw	?
	buffer@ 	dd	?
scanner_interface_struc ends

buffer@_off		EQU	word ptr buffer@
buffer@_seg		EQU	word ptr buffer@ + 2

@ResetScanner		EQU	0

@StartScanner		EQU	1

@StopScanner		EQU	2

@SetDataType		EQU	3
;=================================================================
; i/p								;;
	data_type		EQU	scan_variety		;;
; o/p								;;
;	scan_return = the real style of image			;;
;---------------------------------------------------------------;;
	@ThresholdedData	EQU	'0'                     ;;
	@WhiteData		EQU	'1'                     ;;
	@BlackData		EQU	'2'                     ;;
	@DitheredData		EQU	'3'                     ;;
	@GrayScale		EQU	'4'                     ;;
	@ColorRGBRGB		EQU	'5'                     ;;
	@ColorRRGGBB		EQU	'6'                     ;;
;=================================================================

@SetXYResolution	EQU	4
;=================================================================
; i/p								;;
	x_ppi			EQU	word ptr buffer@	;;
	y_ppi			EQU	word ptr buffer@ + 2	;;
;---------------------------------------------------------------;;
	@75DPI			EQU	2 * 0			;;
	@100DPI 		EQU	2 * 1			;;
	@150DPI 		EQU	2 * 2			;;
	@200DPI 		EQU	2 * 3			;;
	@300DPI 		EQU	2 * 4			;;
;---------------------------------------------------------------;;
	@PreScanDPI		EQU	@75DPI			;;
;=================================================================

@SetXYPosition		EQU	5
;=================================================================
; i/p								;;
	x_location		EQU	word ptr buffer@	;;
	y_location		EQU	word ptr buffer@ + 2	;;
;=================================================================

@SetXYExtent		EQU	6
;=================================================================
; i/p								;;
	x_extent		EQU	word ptr buffer@	;;
	y_extent		EQU	word ptr buffer@ + 2	;;
;=================================================================

@SetInverse		EQU	7
;=================================================================
; i/p								;;
	inverse_flag		EQU	scan_variety		;;
; o/p								;;
;	scan_return = the real style of image			;;
;---------------------------------------------------------------;;
	@InverseImage		EQU	'1'                     ;;
	@NormalImage		EQU	'0'                     ;;
;---------------------------------------------------------------;;
	@DefaultImage		EQU	@InverseImage		;;
;=================================================================

@ScannerRead		EQU	8
;=================================================================
; i/p								;;
;	buffer_leng = number of bytes to read			;;
;	buffer@     = address of buffer 			;;
;=================================================================

@ScannerDataWidth	EQU	9
;=================================================================
; i/p								;;
	@Gray8Bits	EQU	8
	@Color8Bits	EQU	8
	data_width_def	EQU	Scan_Variety			;;
;=================================================================

@InquireScanInfo	EQU	10
;=================================================================
	line_pixels	EQU	buffer_leng
	line_bytes	EQU	word ptr buffer@
	lines_scan	EQU	word ptr buffer@ + 2
;=================================================================

;
; Calling procedures
;
;	1. Prepare the interface communication block
;	2. DS:BX pointer to the communication block
;	3. Far call the driver
;	4. Check the return field if any to update the original settings
;	   (many parameters depend on the SCANNER, so should accord to
;	    the driver for proper values)

;ͻ
;								       
;ͼ

@1inch			EQU	@PixelsPerInch / @PreViewFactor

;ͻ
;								       
;ͼ
;
; (x0, y0) = 4	 (x?, y0) = 3	(x1, y0) = 5
;
; (x0, y?) = 1			(x1, y?) = 2
;
; (x0, y1) = 7	 (x?, y1) = 6	(x1, y1) = 8

@X0			EQU	1
@X1			EQU	2
@Y0			EQU	3
@Y1			EQU	6

call_scan_struc 	struc
	range_pointer	dw	?
	x_range_check	dw	?
	y_range_check	dw	?
	xy_xor_check	dw	?
	xy_change	dw	?
call_scan_struc 	ends

@BeforeX0		EQU	0
@BeforeX1		EQU	2
@BehindX1		EQU	4

@LeftPortion		EQU	0
@MiddlePortion		EQU	2
@RightPortion		EQU	4
@VerticalUp		EQU	6

;ͻ
;								       
;ͼ

@MinimumScanRAM 	EQU	800h	; 32k
@DefaultScanRAM 	EQU	1000h	; 64k

@PixelsPerInch		EQU	300
@Black			EQU	240	; R=G=B=0x00
@InActive		EQU	250	; R=G=B=0x1F

